From cb7c32d8251173e654fc2aa1b7b640ab8e8a3b76 Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Sat, 11 Mar 2023 21:16:12 +0700
Subject: [PATCH 03/13] PLL Abstraction.

---
 forward-alsa/forward-alsa-core.c              |   1 +
 .../forward-passthrough-core.c                |   1 +
 .../forward-passthrough-fd722.c               |  27 +--
 .../forward-passthrough-fd788.c               |  27 +--
 forward-v4l2/forward-v4l2-core.c              |   1 +
 forward-v4l2/forward-v4l2-fd722.c             |  55 ++---
 forward-v4l2/forward-v4l2-fd788.c             |  55 ++---
 forward/forward-core.c                        |  14 ++
 forward/forward-fd722.c                       |  14 +-
 forward/forward-fd788.c                       |  15 +-
 forward/forward-si532x.c                      | 206 ++++++++++++------
 .../forward-si532x.h                          |  16 +-
 include/forward-fd788.h                       |  31 ---
 include/forward-pll.h                         |  53 +++++
 include/forward-si532x.h                      |  60 -----
 include/forward.h                             |   2 +
 16 files changed, 305 insertions(+), 273 deletions(-)
 rename include/forward-fd722.h => forward/forward-si532x.h (74%)
 delete mode 100644 include/forward-fd788.h
 create mode 100644 include/forward-pll.h
 delete mode 100644 include/forward-si532x.h

diff --git a/forward-alsa/forward-alsa-core.c b/forward-alsa/forward-alsa-core.c
index c835be8..831c46e 100644
--- a/forward-alsa/forward-alsa-core.c
+++ b/forward-alsa/forward-alsa-core.c
@@ -209,6 +209,7 @@ static void forward_alsa_io_changed(struct forward_dev *dev, struct forward_io *
 
 static struct forward_extension forward_alsa_ext = {
 	.name = FORWARD_ALSA_MODULE_NAME,
+	.version = FORWARD_VERSION_CODE,
 	.probe = forward_alsa_probe,
 	.reprobe = forward_alsa_reprobe,
 	.remove = forward_alsa_remove,
diff --git a/forward-passthrough/forward-passthrough-core.c b/forward-passthrough/forward-passthrough-core.c
index cfbe176..7cde52d 100644
--- a/forward-passthrough/forward-passthrough-core.c
+++ b/forward-passthrough/forward-passthrough-core.c
@@ -499,6 +499,7 @@ static void forward_passthrough_io_changed(struct forward_dev *dev, struct forwa
  */
 static struct forward_extension forward_passthrough_ext = {
 	.name = FORWARD_PASSTHROUGH_MODULE_NAME,
+	.version = FORWARD_VERSION_CODE,
 	.probe = forward_passthrough_probe,
 	.reprobe = forward_passthrough_reprobe,
 	.remove = forward_passthrough_remove,
diff --git a/forward-passthrough/forward-passthrough-fd722.c b/forward-passthrough/forward-passthrough-fd722.c
index a4c1594..2ff93ce 100644
--- a/forward-passthrough/forward-passthrough-fd722.c
+++ b/forward-passthrough/forward-passthrough-fd722.c
@@ -19,8 +19,7 @@
 */
 
 #include "forward-passthrough.h"
-#include "forward-si532x.h"
-#include "forward-fd722.h"
+#include "forward-pll.h"
 #include "fd722_reg.h"
 
 #include <linux/types.h>
@@ -278,11 +277,11 @@ static void fd722_configure_io(struct forward_passthrough_io *io)
 static void fd722_configure_genlock(struct forward_passthrough_io *io, bool analog)
 {
 	struct forward_passthrough *pass = io->pass;
-	struct forward_si532x *pll = &((struct forward_fd722 *)pass->dev->cfg.private)->pll;
+	struct forward_pll *pll = pass->dev->pll;
 	FD722_SyncGenerator sg = { 0 };
 	FD722_SyncGeneratorField sgf = { 0 };
 	struct forward_passthrough_format *fmt = &io->format;
-	struct forward_si532x_mode mode = { 0 };
+	struct forward_pll_mode *mode;
 	FD722_Genlock gl;
 	int pll_in_freq = 0;
 	int i;
@@ -303,25 +302,21 @@ static void fd722_configure_genlock(struct forward_passthrough_io *io, bool anal
 		gl.mode = io->in_index ? 3 : 2;
 	}
 
-	if (!forward_si532x_find_mode(pll_in_freq, fmt->m, &mode))
+	mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, fmt->m);
+	if (!mode)
 		return;
 
 	FD722_Genlock_W(pass->dev->csr, gl);
 
-	forward_si532x_load_defaults(pll);
-	forward_si532x_configure_factors(pll, mode.bwsel, mode.n1_hs, mode.nc1_ls, mode.n2_hs,
-					 mode.n2_ls, mode.n31, mode.n32);
-
+	pll->ops->switch_mode(pll, mode);
 	if (!analog) {
 		// Hack to avoid PLL->IN->PLL loop stuck
 		FD722_VideoInCS cs;
 		int count = 0;
 
 		// Force Master clock
-		forward_si532x_select_input(pll, 0);
-		forward_si532x_write_reg(pll, 0x04, 0x12);
-		forward_si532x_write_reg(pll, 0x03, 0x55);
-		forward_si532x_calibrate(pll);
+		pll->ops->select_input(pll, 1, false, false);
+		pll->ops->calibrate(pll);
 
 		// Wait for input
 		do {
@@ -331,10 +326,10 @@ static void fd722_configure_genlock(struct forward_passthrough_io *io, bool anal
 		} while ((!cs.modeLocked) && (count < 100));
 
 		// Switch to input clock
-		forward_si532x_write_reg(pll, 0x04, 0x92);
+		pll->ops->select_input(pll, 0, false, true);
 	} else {
-		forward_si532x_select_input(pll, 0);
-		forward_si532x_calibrate(pll);
+		pll->ops->select_input(pll, 0, false, true);
+		pll->ops->calibrate(pll);
 	}
 
 	sg.frameSize = fmt->total_width * fmt->total_height;
diff --git a/forward-passthrough/forward-passthrough-fd788.c b/forward-passthrough/forward-passthrough-fd788.c
index 19ff1e1..af4fcad 100644
--- a/forward-passthrough/forward-passthrough-fd788.c
+++ b/forward-passthrough/forward-passthrough-fd788.c
@@ -19,8 +19,7 @@
 */
 
 #include "forward-passthrough.h"
-#include "forward-si532x.h"
-#include "forward-fd788.h"
+#include "forward-pll.h"
 #include "fd788_reg.h"
 
 #include <linux/types.h>
@@ -256,11 +255,11 @@ static void fd788_configure_io(struct forward_passthrough_io *io)
 static void fd788_configure_genlock(struct forward_passthrough_io *io, bool analog)
 {
 	struct forward_passthrough *pass = io->pass;
-	struct forward_si532x *pll = &((struct forward_fd788 *)pass->dev->cfg.private)->pll;
+	struct forward_pll *pll = pass->dev->pll;
 	FD788_SyncGenerator sg = { 0 };
 	FD788_SyncGeneratorField sgf = { 0 };
 	struct forward_passthrough_format *fmt = &io->format;
-	struct forward_si532x_mode mode = { 0 };
+	struct forward_pll_mode *mode;
 	FD788_Genlock gl;
 	int pll_in_freq = 0;
 	int i;
@@ -281,25 +280,21 @@ static void fd788_configure_genlock(struct forward_passthrough_io *io, bool anal
 		gl.mode = io->in_index ? 3 : 2;
 	}
 
-	if (!forward_si532x_find_mode(pll_in_freq, fmt->m, &mode))
+	mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, fmt->m);
+	if (!mode)
 		return;
 
 	FD788_Genlock_W(pass->dev->csr, gl);
 
-	forward_si532x_load_defaults(pll);
-	forward_si532x_configure_factors(pll, mode.bwsel, mode.n1_hs, mode.nc1_ls, mode.n2_hs,
-					 mode.n2_ls, mode.n31, mode.n32);
-
+	pll->ops->switch_mode(pll, mode);
 	if (!analog) {
 		// Hack to avoid PLL->IN->PLL loop stuck
 		FD788_VideoInCS cs;
 		int count = 0;
 
 		// Force Master clock
-		forward_si532x_select_input(pll, 0);
-		forward_si532x_write_reg(pll, 0x04, 0x12);
-		forward_si532x_write_reg(pll, 0x03, 0x55);
-		forward_si532x_calibrate(pll);
+		pll->ops->select_input(pll, 1, false, false);
+		pll->ops->calibrate(pll);
 
 		// Wait for input
 		do {
@@ -309,10 +304,10 @@ static void fd788_configure_genlock(struct forward_passthrough_io *io, bool anal
 		} while ((!cs.modeLocked) && (count < 100));
 
 		// Switch to input clock
-		forward_si532x_write_reg(pll, 0x04, 0x92);
+		pll->ops->select_input(pll, 0, false, true);
 	} else {
-		forward_si532x_select_input(pll, 0);
-		forward_si532x_calibrate(pll);
+		pll->ops->select_input(pll, 0, false, true);
+		pll->ops->calibrate(pll);
 	}
 
 	sg.frameSize = fmt->total_width * fmt->total_height;
diff --git a/forward-v4l2/forward-v4l2-core.c b/forward-v4l2/forward-v4l2-core.c
index ffda81b..c9273e2 100644
--- a/forward-v4l2/forward-v4l2-core.c
+++ b/forward-v4l2/forward-v4l2-core.c
@@ -204,6 +204,7 @@ static void forward_v4l2_io_changed(struct forward_dev *dev, struct forward_io *
 
 static struct forward_extension forward_v4l2_ext = {
 	.name = FORWARD_V4L2_MODULE_NAME,
+	.version = FORWARD_VERSION_CODE,
 	.probe = forward_v4l2_probe,
 	.reprobe = forward_v4l2_reprobe,
 	.remove = forward_v4l2_remove,
diff --git a/forward-v4l2/forward-v4l2-fd722.c b/forward-v4l2/forward-v4l2-fd722.c
index 151f067..4f1b5b2 100644
--- a/forward-v4l2/forward-v4l2-fd722.c
+++ b/forward-v4l2/forward-v4l2-fd722.c
@@ -21,10 +21,10 @@
 #include "forward-v4l2.h"
 #include "forward-v4l2-io.h"
 
+#include "forward-pll.h"
+
 #include "fd722_reg.h"
 
-#include "forward-si532x.h"
-#include "forward-fd722.h"
 #include "forward-v4l2-ioctl.h"
 #include "forward-v4l2-genlock.h"
 
@@ -56,12 +56,15 @@ static void fd722_check_pll_configuration(struct forward_v4l2 *v4l2)
 	bool clk_m;
 	int i;
 	bool any_m = false;
-	struct forward_si532x *pll = &((struct forward_fd722 *)v4l2->dev->cfg.private)->pll;
+	struct forward_pll *pll = v4l2->dev->pll;
 
 	if ((v4l2->genlock->source != V4L_FORWARD_GENLOCK_SRC_MASTER) ||
 	    (v4l2->genlock->new_source != V4L_FORWARD_GENLOCK_SRC_MASTER))
 		return;
 
+	if (!pll)
+		return;
+
 	mutex_lock(&v4l2->dev->lock);
 
 	freq = FD722_ClockFrequency_R(v4l2->dev->csr);
@@ -81,12 +84,14 @@ static void fd722_check_pll_configuration(struct forward_v4l2 *v4l2)
 	}
 
 	if ((clk_m != any_m) || !clk_valid) {
-		forward_si532x_load_defaults(pll);
-		if (!any_m)
-			forward_si532x_configure_factors(pll, 10, 9, 4, 11, 288, 4, 16);
-		else
-			forward_si532x_configure_factors(pll, 8, 9, 4, 10, 1800, 250, 91);
-		forward_si532x_calibrate(pll);
+		struct forward_pll_mode *mode;
+		mode = pll->ops->find_mode(pll, 0, 0, 148500000, any_m);
+
+		if (!mode)
+			return;
+
+		pll->ops->switch_mode(pll, mode);
+		pll->ops->calibrate(pll);
 
 		for (i = 0; i < 2; i++) {
 			FD722_VideoOutCS ocs;
@@ -720,17 +725,17 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 				struct forward_v4l2_timings *t)
 {
 	struct forward_v4l2 *v4l2 = gl->v4l2;
-	struct forward_si532x *pll = &((struct forward_fd722 *)v4l2->dev->cfg.private)->pll;
+	struct forward_pll *pll = v4l2->dev->pll;
 	FD722_SyncGenerator sg = { 0 };
 	FD722_SyncGeneratorField sgf = { 0 };
+	struct forward_pll_mode *mode = NULL;
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
-		forward_si532x_load_defaults(pll);
-		forward_si532x_configure_factors(pll, 10, 9, 4, 11, 288, 4, 16);
-		forward_si532x_select_input(pll, 1);
-		forward_si532x_calibrate(pll);
+		mode = pll->ops->find_mode(pll, 0, 0, 148500000, false);
+		pll->ops->switch_mode(pll, mode);
+		pll->ops->select_input(pll, 1, false, false);
+		pll->ops->calibrate(pll);
 	} else {
-		struct forward_si532x_mode mode = { 0 };
 		int pll_in_freq = 0;
 		FD722_Genlock gl = FD722_Genlock_R(v4l2->dev->csr);
 
@@ -749,14 +754,12 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		if (!forward_si532x_find_mode(pll_in_freq, t->sdi.m, &mode))
+		mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, t->sdi.m);
+		if (!mode)
 			return -EINVAL;
 
 		FD722_Genlock_W(v4l2->dev->csr, gl);
-
-		forward_si532x_load_defaults(pll);
-		forward_si532x_configure_factors(pll, mode.bwsel, mode.n1_hs, mode.nc1_ls,
-						 mode.n2_hs, mode.n2_ls, mode.n31, mode.n32);
+		pll->ops->switch_mode(pll, mode);
 
 		if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) || (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
 			// Hack to avoid PLL->IN->PLL loop stuck
@@ -764,10 +767,8 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 			int count = 0;
 
 			// Force Master clock
-			forward_si532x_select_input(pll, 0);
-			forward_si532x_write_reg(pll, 0x04, 0x12);
-			forward_si532x_write_reg(pll, 0x03, 0x55);
-			forward_si532x_calibrate(pll);
+			pll->ops->select_input(pll, 1, false, false);
+			pll->ops->calibrate(pll);
 
 			// Wait for input
 			do {
@@ -779,10 +780,10 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 			} while ((!cs.modeLocked) && (count < 100));
 
 			// Switch to input clock
-			forward_si532x_write_reg(pll, 0x04, 0x92);
+			pll->ops->select_input(pll, 0, false, true);
 		} else {
-			forward_si532x_select_input(pll, 0);
-			forward_si532x_calibrate(pll);
+			pll->ops->select_input(pll, 0, false, true);
+			pll->ops->calibrate(pll);
 		}
 	}
 
diff --git a/forward-v4l2/forward-v4l2-fd788.c b/forward-v4l2/forward-v4l2-fd788.c
index a107eca..6f5725e 100644
--- a/forward-v4l2/forward-v4l2-fd788.c
+++ b/forward-v4l2/forward-v4l2-fd788.c
@@ -22,9 +22,10 @@
 #include "forward-v4l2-io.h"
 #include "forward-v4l2-genlock.h"
 
+#include "forward-pll.h"
+
 #include <linux/delay.h>
 
-#include "forward-fd788.h"
 #include "fd788_reg.h"
 #include "forward-v4l2-ioctl.h"
 
@@ -53,12 +54,15 @@ static void fd788_check_pll_configuration(struct forward_v4l2 *v4l2)
 	bool clk_m;
 	int i;
 	bool any_m = false;
-	struct forward_si532x *pll = &((struct forward_fd788 *)v4l2->dev->cfg.private)->pll;
+	struct forward_pll *pll = v4l2->dev->pll;
 
 	if ((v4l2->genlock->source != V4L_FORWARD_GENLOCK_SRC_MASTER) ||
 	    (v4l2->genlock->new_source != V4L_FORWARD_GENLOCK_SRC_MASTER))
 		return;
 
+	if (!pll)
+		return;
+
 	mutex_lock(&v4l2->dev->lock);
 
 	freq = FD788_ClockFrequency_R(v4l2->dev->csr);
@@ -86,12 +90,15 @@ static void fd788_check_pll_configuration(struct forward_v4l2 *v4l2)
 	}
 
 	if ((clk_m != any_m) || !clk_valid) {
-		forward_si532x_load_defaults(pll);
-		if (!any_m)
-			forward_si532x_configure_factors(pll, 10, 9, 4, 11, 288, 4, 16);
-		else
-			forward_si532x_configure_factors(pll, 8, 9, 4, 10, 1800, 250, 91);
-		forward_si532x_calibrate(pll);
+		struct forward_pll_mode *mode;
+		mode = pll->ops->find_mode(pll, 0, 0, 148500000, any_m);
+
+		if (!mode)
+			return;
+
+		pll->ops->switch_mode(pll, mode);
+		pll->ops->calibrate(pll);
+
 		for (i = 0; i < 8; i++) {
 			FD788_VideoOutCS ocs;
 			if (v4l2->io[i].state != FORWARD_IO_TX)
@@ -901,17 +908,17 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 				struct forward_v4l2_timings *t)
 {
 	struct forward_v4l2 *v4l2 = gl->v4l2;
-	struct forward_si532x *pll = &((struct forward_fd788 *)v4l2->dev->cfg.private)->pll;
+	struct forward_pll *pll = v4l2->dev->pll;
 	FD788_SyncGenerator sg = { 0 };
 	FD788_SyncGeneratorField sgf = { 0 };
+	struct forward_pll_mode *mode = NULL;
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
-		forward_si532x_load_defaults(pll);
-		forward_si532x_configure_factors(pll, 10, 9, 4, 11, 288, 4, 16);
-		forward_si532x_select_input(pll, 1);
-		forward_si532x_calibrate(pll);
+		mode = pll->ops->find_mode(pll, 0, 0, 148500000, false);
+		pll->ops->switch_mode(pll, mode);
+		pll->ops->select_input(pll, 1, false, false);
+		pll->ops->calibrate(pll);
 	} else {
-		struct forward_si532x_mode mode = { 0 };
 		int pll_in_freq = 0;
 		FD788_Genlock gl = FD788_Genlock_R(v4l2->dev->csr);
 
@@ -930,14 +937,12 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		if (!forward_si532x_find_mode(pll_in_freq, t->sdi.m, &mode))
+		mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, t->sdi.m);
+		if (!mode)
 			return -EINVAL;
 
 		FD788_Genlock_W(v4l2->dev->csr, gl);
-
-		forward_si532x_load_defaults(pll);
-		forward_si532x_configure_factors(pll, mode.bwsel, mode.n1_hs, mode.nc1_ls,
-						 mode.n2_hs, mode.n2_ls, mode.n31, mode.n32);
+		pll->ops->switch_mode(pll, mode);
 
 		if ((src == V4L_FORWARD_GENLOCK_SRC_IN0) || (src == V4L_FORWARD_GENLOCK_SRC_IN1)) {
 			// Hack to avoid PLL->IN->PLL loop stuck
@@ -945,10 +950,8 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 			int count = 0;
 
 			// Force Master clock
-			forward_si532x_select_input(pll, 0);
-			forward_si532x_write_reg(pll, 0x04, 0x12);
-			forward_si532x_write_reg(pll, 0x03, 0x55);
-			forward_si532x_calibrate(pll);
+			pll->ops->select_input(pll, 1, false, false);
+			pll->ops->calibrate(pll);
 
 			// Wait for input
 			do {
@@ -960,10 +963,10 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 			} while ((!cs.modeLocked) && (count < 100));
 
 			// Switch to input clock
-			forward_si532x_write_reg(pll, 0x04, 0x92);
+			pll->ops->select_input(pll, 0, false, true);
 		} else {
-			forward_si532x_select_input(pll, 0);
-			forward_si532x_calibrate(pll);
+			pll->ops->select_input(pll, 0, false, true);
+			pll->ops->calibrate(pll);
 		}
 	}
 
diff --git a/forward/forward-core.c b/forward/forward-core.c
index 883e53f..f4bd17c 100644
--- a/forward/forward-core.c
+++ b/forward/forward-core.c
@@ -664,6 +664,16 @@ int forward_register_extension(struct forward_extension *ext)
 {
 	struct forward_dev *dev;
 
+	if (ext->version != FORWARD_VERSION_CODE) {
+		printk(KERN_ERR FORWARD_MODULE_NAME
+		       ": cannot register extension %s - wrong verion (%d.%d.%d, should be %d.%d.%d)\n",
+		       ext->name, (ext->version >> 16) & 0xFF, (ext->version >> 8) & 0xFF,
+		       (ext->version >> 0) & 0xFF, FORWARD_VERSION_MAJOR, FORWARD_VERSION_MINOR,
+		       FORWARD_VERSION_PATCH);
+
+		return -EINVAL;
+	}
+
 	mutex_lock(&forward_extensions_lock);
 	list_add_tail(&ext->node, &forward_extensions);
 	mutex_unlock(&forward_extensions_lock);
@@ -787,7 +797,11 @@ static struct platform_driver forward_plat_driver = {
 	},
 };
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(6, 2, 0)
+static char *forward_devnode(const struct device *dev, umode_t *mode)
+#else
 static char *forward_devnode(struct device *dev, umode_t *mode)
+#endif
 {
 	size_t size = strlen(dev_name(dev)) + sizeof(FORWARD_CLASS_NAME) + 2;
 	char *result = kmalloc(size, GFP_KERNEL);
diff --git a/forward/forward-fd722.c b/forward/forward-fd722.c
index be7af05..6ce45b0 100644
--- a/forward/forward-fd722.c
+++ b/forward/forward-fd722.c
@@ -21,7 +21,6 @@
 #include "forward.h"
 #include "forward-vdma.h"
 
-#include "forward-fd722.h"
 #include "forward-si532x.h"
 #include "fd722_reg.h"
 
@@ -66,25 +65,16 @@ static bool fd722_i2c_xfer(struct forward_dev *dev, u8 bus, bool read, uint8_t a
 
 static int fd722_init(struct forward_dev *dev)
 {
-	struct forward_fd722 *fd722 =
-		devm_kzalloc(dev->parent_dev, sizeof(struct forward_fd722), GFP_KERNEL);
-	if (!fd722)
-		return -ENOMEM;
-
-	dev->cfg.private = fd722;
 	dev->i2c_xfer = &fd722_i2c_xfer;
 
-	forward_si532x_init(dev, &fd722->pll, 0, FD722_PLL_ADDRESS);
+	forward_si532x_init(dev, &dev->pll, 0, FD722_PLL_ADDRESS, 2);
 
 	return 0;
 }
 
 static void fd722_fini(struct forward_dev *dev)
 {
-	struct forward_fd722 *fd722 = dev->cfg.private;
-	if (dev->cfg.private)
-		devm_kfree(dev->parent_dev, fd722);
-	dev->cfg.private = NULL;
+	forward_si532x_fini(dev, &dev->pll);
 }
 
 static void fd722_read_id(struct forward_dev *dev)
diff --git a/forward/forward-fd788.c b/forward/forward-fd788.c
index ffafab7..008dc77 100644
--- a/forward/forward-fd788.c
+++ b/forward/forward-fd788.c
@@ -21,7 +21,7 @@
 #include "forward.h"
 #include "forward-vdma.h"
 
-#include "forward-fd788.h"
+#include "forward-si532x.h"
 #include "fd788_reg.h"
 
 #include <linux/delay.h>
@@ -70,25 +70,16 @@ static bool fd788_i2c_xfer(struct forward_dev *dev, u8 bus, bool read, uint8_t a
 
 static int fd788_init(struct forward_dev *dev)
 {
-	struct forward_fd788 *fd788 =
-		devm_kzalloc(dev->parent_dev, sizeof(struct forward_fd788), GFP_KERNEL);
-	if (!fd788)
-		return -ENOMEM;
-
-	dev->cfg.private = fd788;
 	dev->i2c_xfer = &fd788_i2c_xfer;
 
-	forward_si532x_init(dev, &fd788->pll, 0, FD788_PLL_ADDRESS);
+	forward_si532x_init(dev, &dev->pll, 0, FD788_PLL_ADDRESS, 2);
 
 	return 0;
 }
 
 static void fd788_fini(struct forward_dev *dev)
 {
-	struct forward_fd788 *fd788 = dev->cfg.private;
-	if (dev->cfg.private)
-		devm_kfree(dev->parent_dev, fd788);
-	dev->cfg.private = NULL;
+	forward_si532x_fini(dev, &dev->pll);
 }
 
 static void fd788_read_id(struct forward_dev *dev)
diff --git a/forward/forward-si532x.c b/forward/forward-si532x.c
index c02f110..568d8e9 100644
--- a/forward/forward-si532x.c
+++ b/forward/forward-si532x.c
@@ -18,7 +18,26 @@
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
-#include "forward-si532x.h"
+#include "forward-pll.h"
+
+struct forward_si532x {
+	struct forward_pll pll;
+
+	u8 bus;
+	u8 address;
+};
+
+struct forward_si532x_mode {
+	int in_freq;
+	bool m;
+	u8 bwsel;
+	u8 n1_hs;
+	u32 nc1_ls;
+	u8 n2_hs;
+	u32 n2_ls;
+	u32 n31;
+	u32 n32;
+};
 
 const struct forward_si532x_mode forward_si532x_modes[] = {
 	{ 13500000 / 200, false, 5, 9, 4, 11, 7200, 1, 400 },
@@ -50,32 +69,26 @@ const struct forward_si532x_mode forward_si532x_modes[] = {
 	{ 148500000, true, 8, 9, 4, 10, 1800, 500, 91 },
 };
 
+const struct forward_si532x_mode si532x_default_mode = { -1, false, 10, 9, 4, 11, 288, 44, 16 };
+const struct forward_si532x_mode si532x_default_mode_m = { -1, true, 8, 9, 4, 10, 1800, 250, 91 };
+
 const int forward_si532x_modes_count =
 	sizeof(forward_si532x_modes) / sizeof(struct forward_si532x_mode);
 
-int forward_si532x_init(struct forward_dev *dev, struct forward_si532x *pll, u8 bus, u8 address)
+static int si532x_write_reg(struct forward_si532x *si532x, u8 reg, u8 data)
 {
-	pll->dev = dev;
-	pll->bus = bus;
-	pll->address = address;
-	return 0;
+	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, false, si532x->address, reg,
+					 &data);
 }
-EXPORT_SYMBOL(forward_si532x_init);
-
-int forward_si532x_write_reg(struct forward_si532x *pll, u8 reg, u8 data)
-{
-	return pll->dev->i2c_xfer(pll->dev, pll->bus, false, pll->address, reg, &data);
-}
-EXPORT_SYMBOL(forward_si532x_write_reg);
 
-int forward_si532x_read_reg(struct forward_si532x *pll, u8 reg, u8 *data)
+static int si532x_read_reg(struct forward_si532x *si532x, u8 reg, u8 *data)
 {
-	return pll->dev->i2c_xfer(pll->dev, pll->bus, true, pll->address, reg, data);
+	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, true, si532x->address, reg,
+					 data);
 }
-EXPORT_SYMBOL(forward_si532x_read_reg);
 
-int forward_si532x_configure_factors(struct forward_si532x *pll, u8 bwsel, u8 n1_hs, u32 nc1_ls,
-				     u8 n2_hs, u32 n2_ls, u32 n31, u32 n32)
+static int si532x_configure_factors(struct forward_si532x *si532x, u8 bwsel, u8 n1_hs, u32 nc1_ls,
+				    u8 n2_hs, u32 n2_ls, u32 n31, u32 n32)
 {
 	u32 reg_value;
 
@@ -100,84 +113,153 @@ int forward_si532x_configure_factors(struct forward_si532x *pll, u8 bwsel, u8 n1
 	if ((n32 < 1) || (n32 > (1 << 19)))
 		return -EINVAL;
 
-	forward_si532x_write_reg(pll, 0x02, (bwsel << 4) | (0x2));
-	forward_si532x_write_reg(pll, 0x19, ((n1_hs - 4) << 5));
+	si532x_write_reg(si532x, 0x02, (bwsel << 4) | (0x2));
+	si532x_write_reg(si532x, 0x19, ((n1_hs - 4) << 5));
 
 	reg_value = nc1_ls - 1;
-	forward_si532x_write_reg(pll, 0x1F, (reg_value >> 16) & 0x0F);
-	forward_si532x_write_reg(pll, 0x20, (reg_value >> 8) & 0xFF);
-	forward_si532x_write_reg(pll, 0x21, reg_value & 0xFF);
+	si532x_write_reg(si532x, 0x1F, (reg_value >> 16) & 0x0F);
+	si532x_write_reg(si532x, 0x20, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x21, reg_value & 0xFF);
 
 	reg_value = n2_ls - 1;
-	forward_si532x_write_reg(pll, 0x28, ((n2_hs - 4) << 5) | ((reg_value >> 16) & 0x0F));
-	forward_si532x_write_reg(pll, 0x29, (reg_value >> 8) & 0xFF);
-	forward_si532x_write_reg(pll, 0x2A, reg_value & 0xFF);
+	si532x_write_reg(si532x, 0x28, ((n2_hs - 4) << 5) | ((reg_value >> 16) & 0x0F));
+	si532x_write_reg(si532x, 0x29, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x2A, reg_value & 0xFF);
 
 	reg_value = n31 - 1;
-	forward_si532x_write_reg(pll, 0x2B, (reg_value >> 16) & 0x07);
-	forward_si532x_write_reg(pll, 0x2C, (reg_value >> 8) & 0xFF);
-	forward_si532x_write_reg(pll, 0x2D, reg_value & 0xFF);
+	si532x_write_reg(si532x, 0x2B, (reg_value >> 16) & 0x07);
+	si532x_write_reg(si532x, 0x2C, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x2D, reg_value & 0xFF);
 
 	reg_value = n32 - 1;
-	forward_si532x_write_reg(pll, 0x2E, (reg_value >> 16) & 0x07);
-	forward_si532x_write_reg(pll, 0x2F, (reg_value >> 8) & 0xFF);
-	forward_si532x_write_reg(pll, 0x30, reg_value & 0xFF);
+	si532x_write_reg(si532x, 0x2E, (reg_value >> 16) & 0x07);
+	si532x_write_reg(si532x, 0x2F, (reg_value >> 8) & 0xFF);
+	si532x_write_reg(si532x, 0x30, reg_value & 0xFF);
 
 	return 0;
 }
-EXPORT_SYMBOL(forward_si532x_configure_factors);
 
-int forward_si532x_load_defaults(struct forward_si532x *pll)
+static int si532x_load_defaults(struct forward_si532x *si532x)
 {
 	// PLL mode, CLK always on, no bypass
-	forward_si532x_write_reg(pll, 0x00, 0x34);
+	si532x_write_reg(si532x, 0x00, 0x34);
 	// CLKIN1 > CLKIN2 priority
-	forward_si532x_write_reg(pll, 0x01, 0xE1);
+	//si532x_write_reg(si532x, 0x01, 0xE1);
 	// No output disabling during calibration, CLKIN2 selected
-	forward_si532x_write_reg(pll, 0x03, 0x55);
+	si532x_write_reg(si532x, 0x03, 0x55);
 	// Automatic clock selection, default hold history
-	forward_si532x_write_reg(pll, 0x04, 0x92);
+	//si532x_write_reg(si532x, 0x04, 0x92);
 	// LVDS outputs
-	forward_si532x_write_reg(pll, 0x06, 0x0F);
+	si532x_write_reg(si532x, 0x06, 0x0F);
 	// External crystal as reference
-	forward_si532x_write_reg(pll, 0x07, 0x28);
+	si532x_write_reg(si532x, 0x07, 0x28);
 	// CLKOUT1 enabled, CLKOUT2 disabled
-	forward_si532x_write_reg(pll, 0x0A, 0x08);
+	si532x_write_reg(si532x, 0x0A, 0x08);
 	// Frequency offset and phase error detector
-	forward_si532x_write_reg(pll, 0x13, 0x2F);
+	si532x_write_reg(si532x, 0x13, 0x2F);
 	// Enable CK2_BAD, LOL, INT pins
-	forward_si532x_write_reg(pll, 0x14, 0x3B);
+	si532x_write_reg(si532x, 0x14, 0x3B);
 	// Disable clock selection pins
-	forward_si532x_write_reg(pll, 0x15, 0xFC);
+	si532x_write_reg(si532x, 0x15, 0xFC);
 	// Enable fast lock
-	forward_si532x_write_reg(pll, 0x89, 0x01);
+	si532x_write_reg(si532x, 0x89, 0x01);
 
 	return 0;
 }
-EXPORT_SYMBOL(forward_si532x_load_defaults);
 
-void forward_si532x_calibrate(struct forward_si532x *pll)
+static struct forward_pll_mode *si532x_find_mode(struct forward_pll *pll, s64 in_freq,
+						 s64 common_in_freq, s64 out_freq, bool m)
 {
-	forward_si532x_write_reg(pll, 0x88, 0x40);
-}
-EXPORT_SYMBOL(forward_si532x_calibrate);
+	int i;
 
-void forward_si532x_select_input(struct forward_si532x *pll, int input)
-{
-	forward_si532x_write_reg(pll, 0x01, (input == 1) ? 0xE1 : 0xE4);
-}
-EXPORT_SYMBOL(forward_si532x_select_input);
+	if (out_freq != 148500000)
+		return NULL;
+
+	if (in_freq <= 0) {
+		if (!m)
+			return (struct forward_pll_mode *)&si532x_default_mode;
+		else
+			return (struct forward_pll_mode *)&si532x_default_mode_m;
+	}
 
-bool forward_si532x_find_mode(int in_freq, bool m, struct forward_si532x_mode *mode)
-{
-	int i;
 	for (i = 0; i < forward_si532x_modes_count; i++) {
 		const struct forward_si532x_mode *cur = &forward_si532x_modes[i];
 		if ((cur->in_freq == in_freq) && (cur->m == m)) {
-			*mode = *cur;
-			return true;
+			return (struct forward_pll_mode *)cur;
 		}
 	}
-	return false;
+	return NULL;
+}
+
+static int si532x_switch_mode(struct forward_pll *pll, struct forward_pll_mode *mode)
+{
+	struct forward_si532x *si532x = container_of(pll, struct forward_si532x, pll);
+	struct forward_si532x_mode *m = (struct forward_si532x_mode *)mode;
+
+	if (mode == NULL)
+		return -EINVAL;
+
+	si532x_load_defaults(si532x);
+	si532x_configure_factors(si532x, m->bwsel, m->n1_hs, m->nc1_ls, m->n2_hs, m->n2_ls, m->n31,
+				 m->n32);
+
+	return 0;
+}
+
+static int si532x_select_input(struct forward_pll *pll, int input, bool master, bool autoswitch)
+{
+	struct forward_si532x *si532x = container_of(pll, struct forward_si532x, pll);
+
+	si532x_write_reg(si532x, 0x04, autoswitch ? 0x92 : 0x12);
+	si532x_write_reg(si532x, 0x03, (input == 1) ? 0x55 : 0x15);
+	si532x_write_reg(si532x, 0x01, (input == 1) ? 0xE1 : 0xE4);
+
+	return 0;
+}
+
+int si532x_tune(struct forward_pll *pll, s64 ppt)
+{
+	return -ENOTSUPP;
+}
+
+void si532x_calibrate(struct forward_pll *pll)
+{
+	struct forward_si532x *si532x = container_of(pll, struct forward_si532x, pll);
+	si532x_write_reg(si532x, 0x88, 0x40);
+}
+
+static struct forward_pll_ops si5324_ops = { .find_mode = si532x_find_mode,
+					     .switch_mode = si532x_switch_mode,
+					     .select_input = si532x_select_input,
+					     .tune = si532x_tune,
+					     .calibrate = si532x_calibrate };
+
+int forward_si532x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bus, u8 address,
+			int num_inputs)
+{
+	struct forward_si532x *si532x = kzalloc(sizeof(struct forward_si532x), GFP_KERNEL);
+	if (!si532x)
+		return -ENOMEM;
+
+	si532x->pll.dev = dev;
+	si532x->pll.features = FORWARD_PLL_FEATURE_FALLBACK;
+	si532x->pll.num_inputs = num_inputs;
+	si532x->pll.ops = &si5324_ops;
+	si532x->bus = bus;
+	si532x->address = address;
+
+	*pll = &si532x->pll;
+
+	return 0;
+}
+EXPORT_SYMBOL(forward_si532x_init);
+
+void forward_si532x_fini(struct forward_dev *dev, struct forward_pll **pll)
+{
+	if (pll) {
+		struct forward_si532x *si532x = container_of(*pll, struct forward_si532x, pll);
+		kfree(si532x);
+		*pll = NULL;
+	}
 }
-EXPORT_SYMBOL(forward_si532x_find_mode);
+EXPORT_SYMBOL(forward_si532x_fini);
diff --git a/include/forward-fd722.h b/forward/forward-si532x.h
similarity index 74%
rename from include/forward-fd722.h
rename to forward/forward-si532x.h
index ce2b4a2..6246ccf 100644
--- a/include/forward-fd722.h
+++ b/forward/forward-si532x.h
@@ -1,5 +1,5 @@
 /*
-   forward-fd722.h - FD722 driver for SoftLab-NSK Forward video boards
+   forward-si532x.h - si532x PLL driver for SoftLab-NSK Forward boards
 
    Copyright (C) 2017 - 2023 Konstantin Oblaukhov <oblaukhov@sl.iae.nsk.su>
 
@@ -18,14 +18,8 @@
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
-#ifndef FORWARD_FD722_H
-#define FORWARD_FD722_H
+#include "forward-pll.h"
 
-#include "forward.h"
-#include "forward-si532x.h"
-
-struct forward_fd722 {
-	struct forward_si532x pll;
-};
-
-#endif
+int forward_si532x_init(struct forward_dev *dev, struct forward_pll **pll, u8 bus, u8 address,
+			int num_inputs);
+void forward_si532x_fini(struct forward_dev *dev, struct forward_pll **pll);
diff --git a/include/forward-pll.h b/include/forward-pll.h
new file mode 100644
index 0000000..a23d080
--- /dev/null
+++ b/include/forward-pll.h
@@ -0,0 +1,53 @@
+/*
+   forward-pll.h - PLL drivers for SoftLab-NSK Forward boards
+
+   Copyright (C) 2017 - 2023 Konstantin Oblaukhov <oblaukhov@sl.iae.nsk.su>
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License
+   as published by the Free Software Foundation; either version 2
+   of the License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*/
+
+#ifndef FORWARD_PLL_H
+#define FORWARD_PLL_H
+
+#include <linux/kernel.h>
+
+#include "forward.h"
+
+struct forward_pll_mode;
+struct forward_pll;
+
+#define FORWARD_PLL_FEATURE_MASTER (1 << 0)
+#define FORWARD_PLL_FEATURE_FALLBACK (1 << 1)
+#define FORWARD_PLL_FEATURE_TUNE (1 << 2)
+
+struct forward_pll_ops {
+	struct forward_pll_mode *(*find_mode)(struct forward_pll *pll, s64 in_freq,
+					      s64 common_in_freq, s64 out_freq, bool m);
+	int (*switch_mode)(struct forward_pll *pll, struct forward_pll_mode *mode);
+	int (*select_input)(struct forward_pll *pll, int input, bool master, bool autoswitch);
+	int (*tune)(struct forward_pll *pll, s64 ppt);
+	void (*calibrate)(struct forward_pll *pll);
+};
+
+struct forward_pll {
+	struct forward_dev *dev;
+
+	int num_inputs;
+	int features;
+
+	struct forward_pll_ops *ops;
+};
+
+#endif
